3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--[no-]single-branch] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] set-url [--] <path> <newurl>
16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17 or: $dashless [--quiet] foreach [--recursive] <command>
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
24 wt_prefix=$(git rev-parse --show-prefix)
27 # Tell the rest of git that any URLs we get don't come
28 # directly from the user, so it can apply policy as appropriate.
29 GIT_PROTOCOL_FROM_USER=0
30 export GIT_PROTOCOL_FROM_USER
55 if test "$1" = "#unmatched"
63 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
66 # Given a full hex object ID, is this the zero OID?
68 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
71 # Sanitize the local git environment for use within a submodule. We
72 # can't simply use clear_local_git_env since we want to preserve some
73 # of the settings from GIT_CONFIG_PARAMETERS.
74 sanitize_submodule_env()
76 save_config=$GIT_CONFIG_PARAMETERS
78 GIT_CONFIG_PARAMETERS=$save_config
79 export GIT_CONFIG_PARAMETERS
83 # Add a new submodule to the working tree, .gitmodules and the index
87 # optional branch is stored in global branch variable
91 # parse $args after "submodule ... add".
97 case "$2" in '') usage ;; esac
111 case "$2" in '') usage ;; esac
116 reference_path="${1#--reference=}"
122 case "$2" in '') usage ;; esac
127 case "$2" in '') usage ;; esac
148 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
150 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
153 if test -n "$reference_path"
155 is_absolute_path "$reference_path" ||
156 reference_path="$wt_prefix$reference_path"
158 reference="--reference=$reference_path"
164 if test -z "$sm_path"; then
165 sm_path=$(printf '%s\n' "$repo" |
166 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 if test -z "$repo" || test -z "$sm_path"; then
173 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
175 # assure repo is absolute or relative to parent
178 test -z "$wt_prefix" ||
179 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
181 # dereference source url relative to parent's url
182 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
189 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
194 # multiple //; leading ./; /./; /../; trailing /
195 sm_path=$(printf '%s/\n' "$sm_path" |
207 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
208 die "$(eval_gettext "'\$sm_path' already exists in the index")"
210 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214 if test -d "$sm_path" &&
215 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
217 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
218 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
223 dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
232 if test -n "$custom_name"
234 sm_name="$custom_name"
239 if ! git submodule--helper check-name "$sm_name"
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
244 # perhaps the path exists and is already a git repo, else clone it
245 if test -e "$sm_path"
247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
255 if test -d ".git/modules/$sm_name"
259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
261 die "$(eval_gettextln "\
262 If you want to reuse this local git directory instead of cloning again from
264 use the '--force' option. If the local git directory is not the correct repo
265 or you are unsure what this means choose another name with the '--name' option.")"
267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
272 sanitize_submodule_env
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
281 git config submodule."$sm_name".url "$realrepo"
283 git add --no-warn-embedded-repo $force "$sm_path" ||
284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
286 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
287 git submodule--helper config submodule."$sm_name".url "$repo" &&
290 git submodule--helper config submodule."$sm_name".branch "$branch"
292 git add --force .gitmodules ||
293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
303 git config submodule."$sm_name".active "true"
306 git config submodule."$sm_name".active "true"
311 # Execute an arbitrary command sequence in each checked out
314 # $@ = command to execute
318 # parse $args after "submodule ... foreach".
338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
342 # Register submodules in .git/config
344 # $@ = requested paths (default to all)
348 # parse $args after "submodule ... init".
369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
373 # Unregister submodules from .git/config and remove their work tree
377 # parse $args after "submodule ... deinit".
405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
408 is_tip_reachable () (
409 sanitize_submodule_env &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
415 # usage: fetch_in_submodule <module_path> [<depth>] [<sha1>]
416 # Because arguments are positional, use an empty string to omit <depth>
417 # but include <sha1>.
418 fetch_in_submodule () (
419 sanitize_submodule_env &&
423 echo "$3" | git fetch --stdin ${2:+"$2"}
430 # Update each submodule path to correct revision, using clone and checkout as needed
432 # $@ = requested paths (default to all)
436 # parse $args after "submodule ... update".
469 case "$2" in '') usage ;; esac
470 reference="--reference=$2"
489 recommend_shallow="--recommend-shallow"
491 --no-recommend-shallow)
492 recommend_shallow="--no-recommend-shallow"
495 case "$2" in '') usage ;; esac
503 case "$2" in '') usage ;; esac
511 single_branch="--single-branch"
514 single_branch="--no-single-branch"
532 cmd_init "--" "$@" || return
536 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
537 ${progress:+"--progress"} \
538 ${wt_prefix:+--prefix "$wt_prefix"} \
539 ${prefix:+--recursive-prefix "$prefix"} \
540 ${update:+--update "$update"} \
541 ${reference:+"$reference"} \
542 ${dissociate:+"--dissociate"} \
543 ${depth:+--depth "$depth"} \
544 ${require_init:+--require-init} \
549 "$@" || echo "#unmatched" $?
552 while read -r quickabort sha1 just_cloned sm_path
554 die_if_unmatched "$quickabort" "$sha1"
556 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
558 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
560 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
562 if test $just_cloned -eq 1
566 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
567 git rev-parse --verify HEAD) ||
568 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
573 branch=$(git submodule--helper remote-branch "$sm_path")
574 if test -z "$nofetch"
576 # Fetch remote before determining tracking $sha1
577 fetch_in_submodule "$sm_path" $depth ||
578 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
580 remote_name=$(sanitize_submodule_env; cd "$sm_path" && git submodule--helper print-default-remote)
581 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
582 git rev-parse --verify "${remote_name}/${branch}") ||
583 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
586 if test "$subsha1" != "$sha1" || test -n "$force"
589 # If we don't already have a -f flag and the submodule has never been checked out
590 if test -z "$subsha1" && test -z "$force"
595 if test -z "$nofetch"
597 # Run fetch only if $sha1 isn't present or it
598 # is not reachable from a ref.
599 is_tip_reachable "$sm_path" "$sha1" ||
600 fetch_in_submodule "$sm_path" $depth ||
601 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
603 # Now we tried the usual fetch, but $sha1 may
604 # not be reachable from any of the refs
605 is_tip_reachable "$sm_path" "$sha1" ||
606 fetch_in_submodule "$sm_path" "$depth" "$sha1" ||
607 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
611 case "$update_module" in
613 command="git checkout $subforce -q"
614 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
615 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
618 command="git rebase ${GIT_QUIET:+--quiet}"
619 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
620 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
621 must_die_on_failure=yes
624 command="git merge ${GIT_QUIET:+--quiet}"
625 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
626 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
627 must_die_on_failure=yes
630 command="${update_module#!}"
631 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
632 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
633 must_die_on_failure=yes
636 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
639 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
642 elif test -n "$must_die_on_failure"
644 die_with_status 2 "$die_msg"
646 err="${err};$die_msg"
651 if test -n "$recursive"
654 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
656 sanitize_submodule_env
663 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
666 err="${err};$die_msg"
669 die_with_status $res "$die_msg"
693 # Configures a submodule's default branch
695 # $@ = requested path
705 # we don't do anything with this but we need to accept it
711 case "$2" in '') usage ;; esac
729 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper set-branch ${GIT_QUIET:+--quiet} ${branch:+--branch "$branch"} ${default:+--default} -- "$@"
733 # Configures a submodule's remote url
735 # $@ = requested path, requested url
758 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper set-url ${GIT_QUIET:+--quiet} -- "$@"
762 # Show commit summary for submodules in index or working tree
764 # If '--cached' is given, show summary between index and given commit,
765 # or between working tree and given commit
767 # $@ = [commit (default 'HEAD'),] requested paths (default all)
774 # parse $args after "submodule ... summary".
789 isnumber "$summary_limit" || usage
793 summary_limit="${1#--summary-limit=}"
794 isnumber "$summary_limit" || usage
810 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper summary ${prefix:+--prefix "$prefix"} ${files:+--files} ${cached:+--cached} ${for_status:+--for-status} ${summary_limit:+-n $summary_limit} -- "$@"
813 # List all submodules, prefixed with:
814 # - submodule not initialized
815 # + different revision checked out
817 # If --cached was specified the revision in the index will be printed
818 # instead of the currently checked out revision.
820 # $@ = requested paths (default to all)
824 # parse $args after "submodule ... status".
851 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
854 # Sync remote urls for submodules
855 # This makes the value for remote.$remote.url match the value
856 # specified in .gitmodules.
884 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
889 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
892 # This loop parses the command line arguments to find the
893 # subcommand name to dispatch. Parsing of the subcommand specific
894 # options are primarily done by the subcommand implementations.
895 # Subcommand specific options such as --branch and --cached are
896 # parsed here as well, for backward compatibility.
898 while test $# != 0 && test -z "$command"
901 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
931 # No command word defaults to "status"
932 if test -z "$command"
942 # "-b branch" is accepted only by "add" and "set-branch"
943 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
948 # "--cached" is accepted only by "status" and "summary"
949 if test -n "$cached" && test "$command" != status && test "$command" != summary
954 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"